/* 
	Corsix's Image Retargetr
    Copyright (C) 2007 Peter Cawley

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _FRM_MAIN_H_
#define _FRM_MAIN_H_

#include "wx/wxprec.h"
#ifdef __BORLANDC__
    #pragma hdrstop
#endif
#ifndef WX_PRECOMP
    #include "wx/app.h"
    #include "wx/log.h"
    #include "wx/frame.h"
    #include "wx/panel.h"
    #include "wx/timer.h"
    #include "wx/utils.h"
    #include "wx/menu.h"
    #include "wx/msgdlg.h"
    #include "wx/textdlg.h"
    #include "wx/filedlg.h"
    #include "wx/choicdlg.h"
    #include "wx/button.h"
    #include "wx/textctrl.h"
    #include "wx/listbox.h"
    #include "wx/sizer.h"
#endif
#include "wx/txtstrm.h"
#include "wx/numdlg.h"
#include "wx/ffile.h"
#include "wx/process.h"
#include "wx/mimetype.h"

#include "wx/statbox.h"
#include "Retarget.h"

class BitmapControl : public wxPanel
{
public:
	BitmapControl(wxWindow* pParent, wxBitmap& bmpBitmap);

	void SetBitmap(wxBitmap& bmpBitmap);
	void OnErase(wxEraseEvent& event);
	void OnPaint(wxPaintEvent& event);

protected:
	wxBitmap& m_bmpBitmap;

private:
	DECLARE_EVENT_TABLE()
};

class frmMain : public wxFrame
{
public:
    frmMain(const wxString& title, const wxPoint& pos, const wxSize& size);

	enum
	{
		IDC_LoadImage = wxID_HIGHEST + 1,
		IDC_SaveImage,
		IDC_ShowEnergy,
		IDC_Retarget,
		IDC_LiveRetarget,
	};

	void OnLoadImage(wxCommandEvent& e);
	void OnSaveImage(wxCommandEvent& e);
	void OnShowEnergyCheck(wxCommandEvent& e);

	void OnRetarget(wxCommandEvent& e);
	void OnLiveRetarget(wxCommandEvent& e);

private:
	BitmapControl* m_pImagePreview;
	wxButton* m_btnRetarget;

	wxTextCtrl* m_txtRetargetWidth;
	wxTextCtrl* m_txtRetargetHeight;
	wxCheckBox* m_chkShowEnergy;
	wxCheckBox* m_chkShowPathing;

	wxFileDialog m_dlgImageChooser;

	RetargetrToUse m_oRetargetr;
	
	wxBitmap m_bmpImage;

	int m_iPathfindVisTimer;
	static void PathfindVisCallback(unsigned char* pData, int iWidth, int iHeight, frmMain* pForm);

    DECLARE_EVENT_TABLE()
};

#endif