/* 
	Corsix's Image Retargetr
    Copyright (C) 2007 Peter Cawley

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "frmRealtimeRetarget.h"

BEGIN_EVENT_TABLE(frmRealtimeRetarget, wxDialog)
	EVT_ERASE_BACKGROUND(OnErase)
	EVT_SIZE(OnResize)
END_EVENT_TABLE()

frmRealtimeRetarget::frmRealtimeRetarget(wxWindow* parent, const wxString& title, const wxPoint& pos, const wxSize& size, RetargetrToUse& retargetr)
	: wxDialog(parent, wxID_ANY, title, pos, size, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER )
	, m_oRetargetr(retargetr)
{
	SetClientSize(size);
	const unsigned char* pData = retargetr.GetImageData();
	wxImage oImage(retargetr.GetWidth(), retargetr.GetHeight(), const_cast<unsigned char*>(pData), true);
	m_bmpImage = wxBitmap(oImage);
}

void frmRealtimeRetarget::OnErase(wxEraseEvent& event)
{
	bool bOwnDC = false;
	wxDC* dcOutput = event.GetDC();
	if(dcOutput == 0)
	{
		dcOutput = new wxClientDC;
		bOwnDC = true;
	}

	wxMemoryDC temp_dc;
	temp_dc.SelectObject(m_bmpImage);

	dcOutput->Blit(0, 0, m_bmpImage.GetWidth(), m_bmpImage.GetHeight(), &temp_dc, 0, 0);
	
	if(bOwnDC)
		delete dcOutput;
}

void frmRealtimeRetarget::OnResize(wxSizeEvent& event)
{
	m_oRetargetr.RetargetDown(GetClientSize().GetWidth(), GetClientSize().GetHeight());
	const unsigned char* pData = m_oRetargetr.GetImageData();
	wxImage oImage(m_oRetargetr.GetWidth(), m_oRetargetr.GetHeight(), const_cast<unsigned char*>(pData), true);
	m_bmpImage = wxBitmap(oImage);
	Refresh();
}